/// Lower band cutoff frequency must be less than or equal to upper band cutoff frequency.
#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith,
    Copy
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct SignalFilterInvalidCutoffBand {
    #[serde(rename = "lowCutoffFrequency")]
    #[derive_with(with = conjure_object::private::DoubleWrapper)]
    low_cutoff_frequency: f64,
    #[serde(rename = "highCutoffFrequency")]
    #[derive_with(with = conjure_object::private::DoubleWrapper)]
    high_cutoff_frequency: f64,
}
impl SignalFilterInvalidCutoffBand {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(low_cutoff_frequency: f64, high_cutoff_frequency: f64) -> Self {
        Self::builder()
            .low_cutoff_frequency(low_cutoff_frequency)
            .high_cutoff_frequency(high_cutoff_frequency)
            .build()
    }
    #[inline]
    pub fn low_cutoff_frequency(&self) -> f64 {
        self.low_cutoff_frequency
    }
    #[inline]
    pub fn high_cutoff_frequency(&self) -> f64 {
        self.high_cutoff_frequency
    }
}
impl conjure_error::ErrorType for SignalFilterInvalidCutoffBand {
    #[inline]
    fn code() -> conjure_error::ErrorCode {
        conjure_error::ErrorCode::InvalidArgument
    }
    #[inline]
    fn name() -> &'static str {
        "Compute:SignalFilterInvalidCutoffBand"
    }
    #[inline]
    fn safe_args() -> &'static [&'static str] {
        &["highCutoffFrequency", "lowCutoffFrequency"]
    }
}
